import { Predicate, RuleInstance } from './api';
import { Validator } from './Validator';
export declare class Validation extends Validator {
    private readonly invertNext;
    constructor(rules: RuleInstance[], allowNull?: boolean, allowUndefined?: boolean, invertNext?: boolean);
    protected withRule(rule: RuleInstance): this;
    array(): this;
    boolean(): this;
    integer(): this;
    null(): this;
    number(): this;
    numeric(): this;
    object(): this;
    string(): this;
    undefined(): this;
    get not(): Validation;
    anyOf(...validators: Validator[]): this;
    equal(value: any): this;
    exact(value: any): this;
    predicate(test: Predicate, description: string): this;
    between(min: number, max: number): this;
    greaterThan(bound: number): this;
    greaterThanOrEqual(bound: number): this;
    lessThan(bound: number): this;
    lessThanOrEqual(bound: number): this;
    positive(): this;
    negative(): this;
    length(min: number, max?: number): this;
    minLength(min: number): this;
    maxLength(max: number): this;
    empty(): this;
    pattern(regex: RegExp): this;
    contains(str: string): this;
    startsWith(str: string): this;
    endsWith(str: string): this;
    includes(value: any): this;
    every(elementValidator: Validator): this;
    some(elementValidator: Validator): this;
    instanceOf(ctor: Function): this;
    keys(arrayValidator: Validator): this;
    values(arrayValidator: Validator): this;
}
